package geniusweb.references;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;

@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE)
public class PartyWithProfile {
	private final PartyWithParameters party;
	private final ProfileRef profile;

	@JsonCreator
	public PartyWithProfile(@JsonProperty("party") PartyWithParameters party,
			@JsonProperty("profile") ProfileRef profile) {
		if (party == null || profile == null) {
			throw new IllegalArgumentException(
					"party and profile must be not null");
		}
		this.party = party;
		this.profile = profile;
	}

	/**
	 * 
	 * @return the {@link PartyWithParameters}. never null.
	 */
	public PartyWithParameters getParty() {
		return party;

	}

	/**
	 * @return the profile setting for this party. Never null.
	 */
	public ProfileRef getProfile() {
		return profile;
	}

	@Override
	public String toString() {
		return "PartyWithProfile[" + party + "," + profile + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((party == null) ? 0 : party.hashCode());
		result = prime * result + ((profile == null) ? 0 : profile.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		PartyWithProfile other = (PartyWithProfile) obj;
		if (party == null) {
			if (other.party != null)
				return false;
		} else if (!party.equals(other.party))
			return false;
		if (profile == null) {
			if (other.profile != null)
				return false;
		} else if (!profile.equals(other.profile))
			return false;
		return true;
	}
}
